//+------------------------------------------------------------------+
//|                                                   Trix Clean.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern int  TrixPeriod      = 14;
extern int  TrixPrice       = PRICE_CLOSE;
extern int  SignalPeriod    =  0;
extern int  SignalMethod    =  3;
extern bool alertsOn        = true;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

double TrixBuffer[];
double SignBuffer[];
double EmaBuffer1[];
double EmaBuffer2[];
double EmaBuffer3[];
double trend[];
double arrowUp[];
double arrowDn[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,arrowUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,arrowDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,TrixBuffer);
   SetIndexBuffer(3,SignBuffer);
   SetIndexBuffer(4,EmaBuffer1);
   SetIndexBuffer(5,EmaBuffer2);
   SetIndexBuffer(6,EmaBuffer3);
   SetIndexBuffer(7,trend);

   //
   //
   //
   //
   //

   IndicatorShortName("Trix ("+TrixPeriod+","+SignalPeriod+")");
   if (TrixPeriod ==3 && SignalPeriod < 2)
   {
   SetIndexLabel (0,"TrixX0up");
   SetIndexLabel (1,"TrixX0dw");
   }
   else{
   SetIndexLabel (0,"TrixXSigup");
   SetIndexLabel (1,"TrixXSigdw");
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+TrixPeriod);
   int    counted_bars=IndicatorCounted();
   int    limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit  = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,TrixPrice,i);
         EmaBuffer1[i] = EmaBuffer1[i+1]+alpha*(price        -EmaBuffer1[i+1]);
         EmaBuffer2[i] = EmaBuffer2[i+1]+alpha*(EmaBuffer1[i]-EmaBuffer2[i+1]);
         EmaBuffer3[i] = EmaBuffer3[i+1]+alpha*(EmaBuffer2[i]-EmaBuffer3[i+1]);
         
         if (EmaBuffer3[i+1]!=0)
              TrixBuffer[i] = 100*(EmaBuffer3[i]-EmaBuffer3[i+1])/EmaBuffer3[i+1];
         else TrixBuffer[i] = 0.00;
   }   
   for (i=limit;i>=0;i--)
   {
      if (SignalPeriod>1)
            SignBuffer[i] = iMAOnArray(TrixBuffer,0,SignalPeriod,0,SignalMethod,i);
      else  SignBuffer[i] = 0;
      
      //
      //
      //
      //
      //
      
      arrowUp[i] = EMPTY_VALUE;
      arrowDn[i] = EMPTY_VALUE;
      trend[i]   = trend[i+1];
         if (TrixBuffer[i]>SignBuffer[i]) trend[i] =  1;
         if (TrixBuffer[i]<SignBuffer[i]) trend[i] = -1;
         if (trend[i]!=trend[i+1])
         if (trend[i] == 1)
               arrowUp[i] = Low[i] -iATR(NULL,0,20,i)/2.0;
         else  arrowDn[i] = High[i]+iATR(NULL,0,20,i)/2.0;
   }   

   //
   //
   //
   //
   //

   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)                        doAlert(whichBar,"up");
         if (trend[whichBar] ==-1)                        doAlert(whichBar,"down");
      }         
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," trix signal ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"trix signals "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}